<?php

define( 'IN_PORTFOLIO', TRUE );
$location = '../';
include( $location . 'start.php' );

// On inclu le header
include( $location . 'admin/header.php' );

// Rcupration des donnes
if( isset( $_GET['mod'] ) || isset( $_POST['mod'] ) )
{
	$mod = ( isset( $_GET['mod'] ) ) ? htmlentities( $_GET['mod'] ) : htmlentities( $_POST['mod'] );
}
else
{
	$mod = '';
}

if( isset( $_GET['mode'] ) || isset( $_POST['mode'] ) )
{
	$mode = ( isset( $_GET['mode'] ) ) ? htmlentities( $_GET['mode'] ) : htmlentities( $_POST['mode'] );
}
else
{
	$mode = '';
}

if( !is_numeric( $mod ) && $mod != '' )
{
	redirection( 'modules.php' );
}

// Chargement des donnes sur les modules
$Cache->load_table( 'modules' );

// On dfini le template
$Tpl->set_filenames( array( 'modules' => 'admin/modules.tpl' ) );

// Si le formulaire est soumis on enregistre les donnes
if( isset( $_POST['soumettre'] ) )
{
	$Tpl->create_block( 'enregistrement' );
	$erreur = '';

	if( empty( $_POST['nom'] ) )
	{
		$erreur = $langue['erreur_nom_vide'];
	}

	if( $mode == 'modifier' && empty( $erreur ) )
	{
		$modules[$mod]['nom'] 			= htmlentities( trim( $_POST['nom'] ) );
		$modules[$mod]['version'] 		= htmlentities( trim( $_POST['version'] ) );
		$modules[$mod]['auteur_nom'] 	= htmlentities( trim( $_POST['auteur_nom'] ) );
		$modules[$mod]['auteur_mail'] 	= htmlentities( trim( $_POST['auteur_mail'] ) );
		$modules[$mod]['description'] 	= htmlentities( $_POST['description'] );
		$modules[$mod]['activation'] 	= ( isset( $_POST['activation'] ) && $_POST['activation'] == 1 ) ? 1 : 0;

		$Cache->write_in_cache( $modules, 'modules', count( $modules ) );
	}
	elseif( $mode == '' && empty( $erreur ) )
	{
		$modules[] = array(
			'nom' 			=> htmlentities( trim( $_POST['nom'] ) ),
			'version' 		=> htmlentities( trim( $_POST['version'] ) ),
			'auteur_nom' 	=> htmlentities( trim( $_POST['auteur_nom'] ) ),
			'auteur_mail' 	=> htmlentities( trim( $_POST['auteur_mail'] ) ),
			'description' 	=> htmlentities( $_POST['description'] ),
			'activation' 	=> ( isset( $_POST['activation'] ) && $_POST['activation'] == 1 ) ? 1 : 0,
		);
		$Cache->write_in_cache( $modules, 'modules', count( $modules ) );
	}

	$Tpl->assign_vars( array(
		'L_ENREGISTREMENT'	=> empty( $erreur ) ? '<img src="' . $location . 'img/sys/ok.png" width="16" height="16" border="0" style="vertical-align: -25%;" alt="" />&nbsp;' . $langue['enregistrement_reussi'] : '<img src="' . $location . 'img/sys/error.png" width="16" height="16" border="0" style="vertical-align: -25%;" alt="" />&nbsp' . $erreur . '<br />',
	) );
}

// Si on supprime un module
if( $mode == 'supprimer' && $mod != '' )
{
	if( isset( $_POST['confirm_oui'] ) )
	{
		array_splice( $modules, $mod, 1 );
		$Cache->write_in_cache( $modules, 'modules', count( $modules ) );
		redirection( 'modules.php' );
	}
	elseif( isset( $_POST['confirm_non'] ) )
	{
		redirection( 'modules.php' );
	}
	else
	{
		confirmation( 'modules.php', $langue['confirm_suppr_modules'], array( 'mode' => $mode, 'mod' => $mod ) );
	}
}

// Rcupration des donnes sur les modules
if( count( $modules ) != 0 )
{
	$Tpl->create_block( 'mods' );

	foreach( $modules as $id_mod => $values_mod )
	{
		$Tpl->assign_block_vars( 'mod', array(
			'MODULES_NOM'			=> ( $values_mod['activation'] == 1 ? '<span style="color: rgb(0, 170, 0);"><b>' . $values_mod['nom'] . '</b></span>' : '<span style="color: rgb(255, 0, 0);">' . $values_mod['nom'] . '</span>' ) . '<br /><span class="petit">' . stripslashes( $values_mod['description'] ) . '</span>',

			'U_MODULES_EDIT'		=> '<a href="' . ajout_sid( $location . 'admin/modules.php?mode=modifier&amp;mod=' . $id_mod, TRUE ) . '" title="' . $langue['modules_modifier'] . '"><img src="' . $location . 'img/sys/brick_edit.png" width="16" height="16" border="0" align="top" alt="" /></a>',
			'U_MODULES_DEL'			=> '<a href="' . ajout_sid( $location . 'admin/modules.php?mode=supprimer&amp;mod=' . $id_mod, TRUE ) . '" title="' . $langue['modules_supprimer'] . '"><img src="' . $location . 'img/sys/brick_delete.png" width="16" height="16" border="0" align="top" alt="" /></a>',
		) );
	}
}

$Tpl->assign_vars( array(
	'RACINE'					=> $location,
	'MODULE_NOM'				=> $mode == 'modifier' && isset( $modules[$mod] ) ? stripslashes( $modules[$mod]['nom'].'"  style="border:0px; background-color:transparent;' ) : '',
	'MODULE_VERSION'			=> $mode == 'modifier' && isset( $modules[$mod] ) ? stripslashes( $modules[$mod]['version'].'" disabled="disabled" style="border:0px; background-color:transparent;' ) : '',
	'MODULE_AUTEUR_NOM'			=> $mode == 'modifier' && isset( $modules[$mod] ) ? stripslashes( $modules[$mod]['auteur_nom'].'" disabled="disabled" style="border:0px; background-color:transparent;' ) : '',
	'MODULE_AUTEUR_MAIL'		=> $mode == 'modifier' && isset( $modules[$mod] ) ? stripslashes( $modules[$mod]['auteur_mail'].'" disabled="disabled" style="border:0px; background-color:transparent;' ) : '',
	'MODULE_DESCRIPTION'		=> $mode == 'modifier' && isset( $modules[$mod] ) ? stripslashes( 'style="border:0; background-color:transparent;">'. $modules[$mod]['description'] ) : '',
	'MODULE_ACTIVATION'			=> $mode == 'modifier' && isset( $modules[$mod] ) && $modules[$mod]['activation'] == 1 ? 'value="1" checked=checked' : 'value="1"',

	'L_MODULES_TITRE'			=> $langue['modules_titre'],
	'L_MODULES_LISTE'			=> $langue['modules_liste'],
	'L_MODULES_LISTE_EXP'		=> $langue['modules_liste_exp'],
	'L_MODULES_CREATION'		=> $mode == 'modifier' && $mod != '' ? '<img src="' . $location . 'img/sys/brick_edit.png" width="16" height="16" border="0" align="bottom" alt="" /> ' . $langue['modules_edition']  . ' : | <a href="modules.php" title=""><img src="' . $location . 'img/sys/brick_add.png" width="16" height="16" border="0" align="bottom" alt="" />&nbsp;' . $langue['categories_creation'] . '</a>' : '<img src="' . $location . 'img/sys/brick_add.png" width="16" height="16" border="0" align="bottom" alt="" /> ' . $langue['modules_creation'] . ' :',
	'L_MODULES_CREATION_EXP'	=> $mode == 'modifier' && $mod != '' ? $langue['modules_edition_exp'] : $langue['modules_creation_exp'],
	'L_MODULES_NOM'				=> $langue['modules_nom'],
	'L_MODULES_VERSION'			=> $langue['modules_version'],
	'L_MODULES_AUTEUR_NOM'		=> $langue['modules_auteur_nom'],
	'L_MODULES_AUTEUR_MAIL'		=> $langue['modules_auteur_mail'],
	'L_MODULES_DESCRIPTION'		=> $langue['modules_description'],
	'L_MODULES_ACTIVATION'		=> $langue['modules_activation'],
	'L_SOUMETTRE'				=> $langue['soumettre'],
	
	'U_ACTION' 					=> $mode == 'modifier' && $mod != '' ? ajout_sid ( $location . 'admin/modules.php?mode=modifier&amp;mod=' . $mod, TRUE ) : ajout_sid ( $location . 'admin/modules.php', TRUE ),
) );

$Tpl->pparse( 'modules' );

// On inclu le footer
include( $location . 'admin/footer.php' );
?>