<?php

function affiche_page( $id_page, $id_feuille = 0 )
{
	global $pages;

	if( $pages[$id_page]['type'] == 'frame' )
	{
		// onLoad="autoResize(this);"
		return '<center><iframe src="' . $pages[$id_page]['page'][0] . '" id="iframe" frameborder="0" height="' . $pages[$id_page]['height'] . '" width="' . $pages[$id_page]['width'] . '" scrolling="auto"></iframe></center>';
	}
	elseif( $pages[$id_page]['type'] == 'php' )
	{
		include( $pages[$id_page]['page'][0] );
	}
	else
	{
		return stripslashes( $pages[$id_page]['page'][$id_feuille] );
	}
}


function affiche_pagination( $page, $feuille, $rapide = FALSE, $sid = '' )
{
	global $pages, $config;

	$affichage_pages = count( $pages[$page]['page'] ) > 1 ? 'Pages : ' : '';
	for( $i = 0; $i < count( $pages[$page]['page'] ) && count( $pages[$page]['page'] ) > 1; $i++ )
	{
		$href = ( $rapide == TRUE ) ? '#" onclick="xajax_start_edit_form( ' . $page . ', ' . $i . ', \'' . $sid . '\' ); return false;' : ajout_sid( 'index.php?page=' . $page . '&amp;feuille=' . $i . ( ( isset( $pages[$page]['keyword'] ) && $config['url_rewriting'] && $pages[$page]['keyword'] != '' ) ? '&amp;keyword=' . clean_keyword( $pages[$page]['keyword'] ) : '' ), TRUE );
		$affichage_pages .= $feuille != $i ? '<a href="' . $href . '" title="">' . ( $i + 1 ) . '</a>&nbsp;' : '[<b>' . ( $i + 1 ) . '</b>]&nbsp;' ;
	}
	return '<br /><br />' . $affichage_pages;
}

/*--------------------------------------------------------------------------
Fonction de redirection

	$url 		=> URL de redirection
	$lien 		=> l'URL va-t-il servir pour un lien hypertexte ou pour un passage de donnes en POST ?
--------------------------------------------------------------------------*/
function redirection( $url, $lien = FALSE )
{
	header( 'Location: ' . ajout_sid( $url, $lien ) );
	exit();
}

/*--------------------------------------------------------------------------
Liste les langues disponibles pour M_P (dans un <select>)

	$racine 		=> dossier racine
	$name_select 	=> nom du select
	$default_select => entre selectionn par default
--------------------------------------------------------------------------*/
function lister_nationalites( $racine, $name_select, $default_select )
{
	if( $dossier = opendir( $racine ) )
	{
		$dossiers = '<select name="' . $name_select . '" style="width:40px;padding:0px;padding-left:0px;text-decoration:none;background-position:left center;background-repeat:no-repeat;">';
		while( FALSE !== ( $fichier = readdir( $dossier ) ) )
		{
			if( $fichier != '.' && $fichier != '..' && $fichier != 'index.html' )
			{
				if( is_dir( $racine . $fichier ) )
				{
					$selection = ( $fichier == $default_select ) ? 'selected="selected"' : '';
					$dossiers .= '<option style="width:40px;padding:0px;padding-left:20px;text-decoration:none;background-image:url(\'../img/drap/' . $fichier . '.png\');background-position:left center;background-repeat:no-repeat;" value="' . $fichier . '" ' . $selection . '>' . $fichier . '</option>';
				}
			}
		}
		$dossiers .= '</select>';
		closedir( $dossier );
	}

	return $dossiers;
}

/*--------------------------------------------------------------------------
Liste les rpertoires prsents dans un autre rpertoire (dans un <select>)

	$racine 		=> dossier racine
	$name_select 	=> nom du select
	$default_select => entre selectionn par default
--------------------------------------------------------------------------*/
function lister( $racine, $name_select, $default_select )
{
	if( $dossier = opendir( $racine ) )
	{
		$dossiers = '<select name="' . $name_select . '">';
		while( FALSE !== ( $fichier = readdir( $dossier ) ) )
		{
			if( $fichier != '.' && $fichier != '..' && $fichier != 'index.html' )
			{
				if( is_dir( $racine . $fichier ) )
				{
					$selection = ( $fichier == $default_select ) ? 'selected="selected"' : '';
					$dossiers .= '<option value="' . $fichier . '" ' . $selection . '>' . $fichier . '</option>';
				}
			}
		}
		$dossiers .= '</select>';
		closedir( $dossier );
	}

	return $dossiers;
}

/*--------------------------------------------------------------------------
Renvoie la structure du tableau pass en paramtre sous
forme de chane de caractre (qui peut ainsi tre crite
dans un fichier cache par exemple). L'indentation et la mise
en forme du code via des espaces et des \n est prise en
compte.

	$array 		=> Tableau dont la structure sera rcupre
	$array_name => Nom du tableau
--------------------------------------------------------------------------*/
function get_array_code( $array, $array_name )
{
	if ( !function_exists( 'get_array_code_rec' ) )
	{
		function get_array_code_rec($array, $end, $indent = '')
		{
			$str = "array(\n";
			while (list($k, $v) = each($array))
			{
				if (is_array($v))
				{
					$str .= "$indent   '$k' => " . get_array_code_rec($v, FALSE, $indent . '   ');
				}
				else
				{
					$str .= "$indent   '$k' => '" . simpleslashes($v) . "',\n";
				}
			}
			$str .= "$indent)" . (($end) ? ';' : ',') . "\n";
			return ($str);
		}
	}

	$str = '$' . $array_name . ' = ' . get_array_code_rec($array, TRUE);

	return ($str);
}

/*--------------------------------------------------------------------------
Fonction permettant de rajouter des antislashes aux \ et ' uniquement

	$text => texte  modifier
--------------------------------------------------------------------------*/
function simpleslashes( $text )
{
	$text = str_replace( '\\', '\\\\', $text );
	$text = str_replace( "'", "\'", $text );

	return ( $text );
}

/*--------------------------------------------------------------------------
Fonction permettant d'afficher une fentre de confirmation

	$fichier 	=> Fichier cible de la confirmation
	$message 	=> Message de confirmation
	$params 	=> Tableau contenant les paramtres  passer via l'action et des champs cachs
--------------------------------------------------------------------------*/
function confirmation( $fichier, $message, $params )
{
	global $config, $langue, $location, $Tpl;

	$v_action = $fichier;
	$hidden = '';
	$i = 0;
	while ( list($cle, $valeur) = each($params) )
	{
		if ( is_array($valeur) )
		{
			foreach ( $valeur AS $valeur_bis )
			{
				$hidden .= '<input type="hidden" name="' . $cle . '" value="' . $valeur_bis . '" />';
			}
		}
		else
		{
			$v_action .= ( $i == 0 ) ? '?' : '&amp;';
			$v_action .= $cle . '=' . $valeur;
			$hidden .= '<input type="hidden" name="' . $cle . '" value="' . $valeur . '" />';
		}
		$i++;
	}

	$Tpl->set_filenames(array('confirmation' => 'confirmation.tpl'));

	$Tpl->assign_vars( array(
		'L_TITRE' 	=> $langue['con_titre'],
		'L_MESSAGE' => $message,
		'L_OUI' 	=> $langue['oui'],
		'L_NON' 	=> $langue['non'],

		'V_ACTION' 	=> ajout_sid($v_action),

		'HIDDEN' 	=> $hidden
	));

	$Tpl->pparse( 'confirmation' );

	include( $location . 'admin/footer.php' );

	exit;
}

/*--------------------------------------------------------------------------
Fonction permettant d'afficher une fentre d'informations

	$titre 		=> titre de la fentre
	$message 	=> Message de l'information
--------------------------------------------------------------------------*/
function info( $titre, $message )
{
	global $config, $langue, $location, $Tpl;

	$Tpl->set_filenames( array( 'information' => 'information.tpl' ) );

	$Tpl->assign_vars( array(
		'L_TITRE' 	=> $titre,
		'L_MESSAGE' => $message,
	));

	$Tpl->pparse( 'information' );

	include( $location . 'admin/footer.php' );

	exit;
}

/*--------------------------------------------------------------------------
Fonction permettant de lister les pages disponible dans M_P (dans un <select>)

	$nom_select => nom du select
	$lien		=> permet d'exclure ou non les pages de type lien de la liste
--------------------------------------------------------------------------*/
function liste_pages( $nom_select, $lien = FALSE )
{
	global $config, $pages;

	$liste_pages = '<select name="' . $nom_select . '">';
	foreach ( $pages as $id => $valeur )
	{
		$selection = ( $id == $config[$nom_select] ) ? 'selected="selected"' : '';
		$liste_pages .= ( $pages[$id]['type'] == 'lien' && $lien == TRUE ) || $pages[$id]['activation'] != 'oui' ? '' : '<option value="' . $id . '" ' . $selection . '>' . $pages[$id]['titre'] . '</option>';		
	}
	
	$liste_pages .= '</select>';

	return $liste_pages;
}

/*--------------------------------------------------------------------------
Fonction permettant de lister les categories disponible dans M_P (dans un <select>)

	$nom_select => nom du select
	$id_page	=> $id de la page associe dans le formulaire
--------------------------------------------------------------------------*/
function liste_categories( $nom_select, $id_page = NULL )
{
	global $pages, $categories;

	$disabled = ( isset( $pages[$id_page]['emplacement'] ) && $pages[$id_page]['emplacement'] == 'haut' ) ? 'disabled="disabled"' : '';
	$liste_categories = '<select name="' . $nom_select . '" id="' . $nom_select . '"' . $disabled . '>';
	foreach( $categories as $id => $valeur )
	{
		$selection = ( isset( $pages[$id_page]['categorie'] ) && $pages[$id_page]['categorie'] == $id ) ? 'selected="selected"' : '';
		$liste_categories .= ( $categories[$id]['activation'] == 1 ) ? '<option value="' . $id . '" ' . $selection . '>' . $categories[$id]['nom'] . '</option>' : '';
	}
	$liste_categories .= '</select>';

	return $liste_categories;
}

/*--------------------------------------------------------------------------
Fonction permettant de synchroniser les smileys entre FCKeditor et M_P

	$racine => racine du script
--------------------------------------------------------------------------*/
function synchro_smileys( $racine )
{
	// Ouverture du fichier config de FCKeditor
	$fichier = $racine . 'includes/js/fckconfig.js';
	$fichier_array = file( $fichier );

	// Cration de la variable 'FCKConfig.SmileyImages'
	$fichier_config = 'FCKConfig.SmileyImages = [';
	$tour = 0;
	$smileys_rep = opendir( $racine . 'fckeditor/editor/images/smiley' );
	while( ( $smileys_fichier = readdir( $smileys_rep ) ) !== FALSE )
	{
		if ( $smileys_fichier != '.' && $smileys_fichier != '..' && $smileys_fichier != 'Thumbs.db' )
		{
			if( $tour != 0 )
			{
				$fichier_config .= ',';
			}
			$tour++;
			$fichier_config .= '\'' . $smileys_fichier . '\'' ;
		}
	}
	closedir( $smileys_rep );
	$fichier_config .= '] ;';

	// Modification de la variable dans le tableau
	$fichier_array[187] = $fichier_config . "\n";

	// Enregistrement dans le fichier
	$fd = @fopen( $racine . 'includes/js/fckconfig.js', 'w' );
	for( $i = 0; $i < count( $fichier_array ); $i++ )
	{
		fwrite( $fd, $fichier_array[$i] );
	}
	fclose( $fd );
}

/*--------------------------------------------------------------------------
Fonction permettant de lister les fichiers prsent dans un rpertoire

	$dossier => emplacement du rpertoire
--------------------------------------------------------------------------*/
function liste_fichiers( $dossier )
{
	// Dclaration du tableau
	$fichiers = array();

	// Ouverture du rpertoire
	if( $dossier = opendir( $dossier ) )
	{
		while( FALSE !== ( $fichier = readdir( $dossier ) ) )
		{
			if( $fichier != '.' && $fichier != '..' && $fichier != 'index.html' )
			{
				$fichiers[] = $fichier;
			}
		}
		// Fermeture du rpertoire
		closedir( $dossier );
	}

	return $fichiers;
}

/*--------------------------------------------------------------------------
Fonction de nettoyage des phrases cls des caractres spciaux

	$keyword => phrase cl  traiter
--------------------------------------------------------------------------*/
function clean_keyword( $keyword )
{
	$keyword 		= html_entity_decode( $keyword );
    $char_search  	= '';
    $char_replace	= 'cnaaaaaaaeeeeeeeeeiiiiiiiioooooooouuuuuuuuu';
    $keyword    	= strtr( trim( strtolower( $keyword ) ), $char_search, $char_replace );
    $keyword     	= preg_replace( '/[^a-z0-9-]+/', '-', $keyword );
	$keyword   		= trim( $keyword, '-' );
	
	$keyword		= urlencode( $keyword );
    return $keyword;
}

/*--------------------------------------------------------------------------
Fonction permettant de rcrire les URL en .html

	$buffer => buffer de sortie  modifier
--------------------------------------------------------------------------*/
function replace_mod_rewrite( $buffer )
{
	// URLs d'entre
	$url_in = array(
		'#index\.php\?page=([0-9]+)#i',
		'#index\.php#i',
		
		'#forum_forum\.php\?id=([0-9]+)&titre=([a-zA-Z0-9-]+)#i',
		'#forum_forum\.php\?id=([0-9]+)#i',
		
		'#forum\.php#i',
		'#forum_sujet_edite\.php\?id=([0-9]+)&mode=([a-zA-Z0-9-]+)#i',
		'#forum_new_treed.php?id=([0-9]+)#i',

		'#forum_sujet\.php\?id=([0-9]+)&titre=([a-zA-Z0-9-]+)&page=([0-9]+)&citer=([0-9]+)#i',
		'#forum_sujet\.php\?id=([0-9]+)&titre=([a-zA-Z0-9-]+)&page=([0-9]+)#i',
		'#forum_sujet\.php\?id=([0-9]+)&titre=([a-zA-Z0-9-]+)&mode=ko#i',
		'#forum_sujet\.php\?id=([0-9]+)&titre=([a-zA-Z0-9-]+)&mode=ok#i',
		'#forum_sujet\.php\?id=([0-9]+)&titre=([a-zA-Z0-9-]+)#i',

		'#liste_membre\.php\?page=([0-9]+)#i',
		'#liste_membre\.php#i',
		
		'#calendar\.php\?mode=([a-zA-Z0-9-]+)#i',
		'#calendar\.php#i',
		'#video\.php\?mode=([a-zA-Z0-9-]+)&page=([0-9]+)#i',
		'#video\.php\?mode=([a-zA-Z0-9-]+)#i',
		'#video\.php#i',
		
		'#sujet_video\.php\?img=([0-9]+)#i',
		
		'#calendar_annonce\.php\?id=([0-9]+)#i',
		'#profil_membre\.php\?id=([0-9]+)&&mode=([a-zA-Z0-9]+)&&mpto=([a-zA-Z0-9]+)#i',
		'#profil_membre\.php\?id=([0-9]+)&mode=([a-zA-Z0-9]+)#i',
		'#profil_membre\.php\?id=([0-9]+)&titre=([a-zA-Z0-9]+)#i',
		'#profil_membre\.php\?id=([0-9]+)#i',
		
		'#sujet_news\.php\?id=([0-9]+)&titre=([a-zA-Z0-9-]+)#i',
		'#mp\.php\?id=([0-9]+)&mode=edite_reply&id_mp=([0-9]+)#i',
		'#mp\.php\?id=([0-9]+)#i',
		'#raid\.php\?mode=([0-9]+)&boss=([0-9]+)#i',
		'#raid\.php\?mode=([0-9]+)#i',
		'#roster\.php#i',
		'#apply\.php#i',
		'#tchatbox\.php#i',
		'#info\.php\?mode=([a-zA-Z0-9-]+)#i',
		
		'#registerLogin\.php\?mode=([a-zA-Z0-9-]+)#i',
		'#registerLogin\.php#i',
		'#news_archive\.php#i',
	);

	// URLs de sortie
   $url_out = array(
   		'index-p\\1.html',
   		'index.html',
		
   		'topic-\\1-\\2.html',
		'topic-\\1.html',
		
   		'forum.html',
		'edit-sujet-\\1-\\2',
		'nouveau_sujet-\\1',
		
		'sujet.\\1.\\2.page.\\3.citation.\\4.html',
		'sujet-\\1-\\2.page-\\3.html',
		'sujet.\\1.\\2.mode.ko.html',
		'sujet.\\1.\\2.mode.ok.html',
		'sujet-\\1-\\2.html',
		
		'liste_membre-p\\1.html',
		'liste_membre.html',
		'calendrier-\\1.html',
		'calendrier.html',
		'video-\\1.p\\2.html',
		'video-\\1.html',
		'video.html',
		
		'media.\\1.html',
   		
		'calendrier-f\\1.html',
		'sendmp-\\1.mode-\\2.to-\\3.html',
		'profil-\\1-mode-\\2.html',
		'profil-\\1-membre-\\2.html',
		'profil-\\1.html',
		
		'news-\\1-\\2.html',
		'mp-\\1-edite-\\2.html',
		'mp-\\1.html',
		'raid-\\1-\\2.html',
		'raid-\\1.html',
		'roster.html',
		'apply.html',
		'tchat.html',
		'information-\\1.html',
		
		'create_login-\\1.html',
		'create_login.html',
		'archive.html',
	);

	// Traitement des URLs
	$buffer = preg_replace( $url_in, $url_out, $buffer );

	// Renvoi du buffer
	return $buffer;
}

/*--------------------------------------------------------------------------
Fonction permettant d'crire dans le fichier .htaccess (Gestion des erreurs et de l'URL Rewriting)

	$racine => racine du script
--------------------------------------------------------------------------*/
function string_gen()
{
	// definition de la taille de la chaine (il sera compris entre 5 et 10 caractres)
	$taille = rand( 5, 100 );

	//tableau des consonnes
	$c1 = array( 'b', 'c', 'd', 'f', 'g', 'h', 'j', 'k', 'l', 'm', 'n', 'p', 'q', 'r', 's', 't', 'v', 'w', 'x', 'z', 'dd', 'ff', 'll', 'mm', 'nn', 'pp', 'rr', 'ss', 'tt' );

	//tableau des voyelles. certaines voyelles ont t doubles ou tripl, comme le a ou le e, car elles sont tres repandu, contrairement au y
	$c2 = array( 'a', 'a', 'a', 'e', 'e', 'e', 'i', 'i', 'o', 'o', 'u', 'u', 'y' );

	// Initialisation et gnration du code
	$code = '';
	for( $i = 1; $i < $taille; $i++ )
	{
		$code .= ( $i%2 == 0 ) ? $c1[rand( 0, count( $c1 ) -1 )] : $c2[rand( 0, count( $c2 ) -1 )];
	}

	// Ajout d'un nombre supplmentaire compris entre 0 et 999
	$code .= '_' . rand( 0, 999 );

	// Renvoi du code
	return $code;
}

/*--------------------------------------------------------------------------
Fonction de vrification de la syntaxe des adresses email

	$email => adresse email  tester
--------------------------------------------------------------------------*/
function email_verif( $email )
{
	$syntaxe = '#^[\w.-]+@[\w.-]+\.[a-zA-Z]{2,5}$#';
	if( preg_match( $syntaxe, $email ) )
	{
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}

/*--------------------------------------------------------------------------
Fonction permettant de vider un rpertoire de ses fichiers

	$email => emplacement du rpertoire  vider
--------------------------------------------------------------------------*/
function empty_dir( $path )
{
	if( $dir_handle = opendir( $path ) )
	{
		while( $file = readdir( $dir_handle ) )
		{
			if( $file == "." || $file == ".." )
			{
				if( !@unlink( $path . '/' . $file ) )
				{
					continue;
				}
			}
			else
			{
				@unlink( $path . '/' . $file );
			}
		}
		closedir( $dir_handle );
		return true;
	}
	else
	{
		return false;
	}
}

/*----------------------------------------------------------------------------
Fonction Wpm-editor

-----------------------------------------------------------------------------*/

	function wpmsmilies($variable) { 
        $research = array( 
				'/\:\)/',
				'/\;\)/',
				'/\:\(/',
				'/\:\[/',
				'/Oo/',
				'/\:x/',
				'/\:X/',
				'/\:s/',
				'/\:S/',
				'/\:P/',
				'/\:p/',
				'/8\)/',
				'/\:\|/',
				'/\:\@/',
				'/\:green\:/',
				'/\:D/',
				'/\:d/',
				'/\:lol\:/',
				'/\:goute\:/',
				'/\:grr\:/',
				'/\:o/',
				'/\:whist\:/',
                ); 
				
        $remplace = array( 
				' <img src="fckeditor/editor/images/smiley/msn/regular_smile.gif" alt="" >',
				' <img src="fckeditor/editor/images/smiley/msn/wink.gif" alt="">', 
				' <img src="fckeditor/editor/images/smiley/msn/sad.gif" alt="">', 
				' <img src="fckeditor/editor/images/smiley/msn/cry.gif" alt="">', 
				' <img src="fckeditor/editor/images/smiley/msn/surprised.gif" alt="">', 
				' <img src="fckeditor/editor/images/smiley/msn/sick.gif" alt="">', 
				' <img src="fckeditor/editor/images/smiley/msn/sick.gif" alt="">',
				' <img src="fckeditor/editor/images/smiley/msn/confused_smile.gif" alt="">',
				' <img src="fckeditor/editor/images/smiley/msn/confused_smile.gif" alt="">',
				' <img src="fckeditor/editor/images/smiley/msn/tongue.gif" alt="">',
				' <img src="fckeditor/editor/images/smiley/msn/tongue.gif" alt="">',
				' <img src="fckeditor/editor/images/smiley/msn/cool.gif" alt="">',
				' <img src="fckeditor/editor/images/smiley/msn/whatchutalkingabout_smile.gif" alt=""> ',
				' <img src="fckeditor/editor/images/smiley/msn/red.gif" alt="">',
				' <img src="fckeditor/editor/images/smiley/msn/green.gif" alt="">',
				' <img src="fckeditor/editor/images/smiley/msn/laugh.gif" alt="">',
				' <img src="fckeditor/editor/images/smiley/msn/laugh.gif" alt="">',
				' <img src="fckeditor/editor/images/smiley/msn/lol.gif" alt="">',
				' <img src="fckeditor/editor/images/smiley/msn/goutes.gif" alt="">',
				' <img src="fckeditor/editor/images/smiley/msn/angry_smile.gif" alt="">' ,
				' <img src="fckeditor/editor/images/smiley/msn/shocked.gif" alt="">',
				' <img src="fckeditor/editor/images/smiley/msn/whistling.gif" alt="">',
                ); 

        $variable = preg_replace ($research, $remplace, $variable); 
        return $variable; 
}


function cutadresse($texte, $length = 20)
{
	if (strlen($texte) > $length)
		return substr($texte , 0, 8 ) . '[...]' . substr($texte , -8);
	else
		return $texte;
}

function parse_url_email($texte)
{	
	$texte = preg_replace("#(^|[\n ])([\w]+?://[^ \"\n\r\t<]*)#is", '\\1<a href=\"\\2\" target=\"_blank\">\\2</a>', $texte);
	$texte = preg_replace("#(^|[\n ])((www|ftp)\.([^ \"\t\n\r<]){3,})#is", '\\1<a href=\"http://\\2\" target=\"_blank\">http://\\2</a>', $texte);
	$texte = preg_replace("#(^|[\n ])([a-z0-9&\-_.]+?)@([\w\-]+\.([\w\-\.]+\.)*[\w]+)#i", '\\1<a href=\"mailto:\\2@\\3\">'.cutadresse("\\2").'@\\3</a>', $texte);
	return $texte;
}


		
/************************************
* Parse les wpmcode du texte,  utiliser lors de la lecture d'un texte
*	$parse_url :: active ou non le rempalcement automatique des mails et urls sans wpmcode
************************************/
function wpmcode_parse($texte, $parse_url_email = TRUE)
{
	global $langue, $theme;
	$secret_time = time();

	preg_match_all("`\[code\](.*?)\[/code\]`si", $texte, $matches);
	$nb_matches = count($matches[1]);
	for ($i = 0; $i < $nb_matches; $i++)
	{
		$origine = $matches[1][$i];
		$remplacement = $matches[1][$i];
		$remplacement = wpmcode2fs($remplacement);
		$remplacement = str_replace("  ", "&nbsp; ", $remplacement);
		$remplacement = str_replace("  ", " &nbsp;", $remplacement);
		$remplacement = str_replace("\t", "&nbsp; &nbsp;", $remplacement);
		$remplacement = preg_replace("/^ {1}/m", '&nbsp;', $remplacement);
		$origine = '[code]' . $origine . '[/code]';
		$remplacement = '[code]' .$remplacement . '[/code]';
		$texte = str_replace($origine, $remplacement,  $texte);
	}

	$texte = wpmcode_subparse($texte, '(\[code\]|&fs1;code&fs2;)', '(\[/code\]|&fs1;\/code&fs2;)', sprintf($theme['code_ouvert'], '90%'), $theme['code_ferme']);
	$texte = wpmcode_subparse($texte, '(\[citer\])', '(\[/citer\])', sprintf($theme['quote_ouvert'], '90%', 'citation'), $theme['quote_ferme']);
	$texte = preg_replace("`\[citer=(.*?)\](.*?)\[/citer\]`si", '<p><table style="width: 90%; border:1px solid #BDCC89" align="center" cellspacing="0" cellpadding="3"><tr><td style="background-color:#D9E5AA;">\\1</td></tr><tr><td style="background-color:#FFF; color:#333">\\2</td></tr></table></p>', $texte);
	$texte = preg_replace("`\[php\](.*?)\[/php\]`si", '<p><table style="width: 90%; border:1px solid #4C1111" align="center" cellspacing="0" cellpadding="3"><tr><td style="background-color:#F5E1E1; border:1px solid #4C1111; border-width: 0px 0px 1px 0px">&lt;?php</td></tr><tr><td style="background-color:#FFF; color:#333"> \\1 </td></tr></table></p>', $texte);

	$texte = parse_list($texte);
	$texte = preg_replace("`\[liste\](.*?)\[/liste\]`si", '<ul>\\1</ul>', $texte);
	$texte = parse_simple_wpmcode($texte, 'b', '<span class="b">', '</span>');
	$texte = parse_simple_wpmcode($texte, 'i', '<span class="i">', '</span>');
	$texte = parse_simple_wpmcode($texte, 'u', '<span class="u">', '</span>');
	$texte = wpmcode_subparse($texte, '(\[couleur=(.*?)\])', '(\[/couleur\])', '<span style="color:#%s;">', '</span>', 'couleur');
	$texte = wpmcode_subparse($texte, '(\[taille=([[:digit:]-]{1,2})\])', '(\[/taille\])', '<span style="font-size:%spx">', '</span>', 'taille');
	
	$texte = preg_replace('`\[url\](http://|https://|ftp://|ftps://|www\.)(.*?)\[/url\]`si', '<a href="\\1\\2" target="_blank">\\1\\2</a>', $texte);
	$texte = preg_replace('`\[url=(http://|https://|ftp://|ftps://|www\.)(.*?)\](.*?)\[/url\]`si', '<a href="\\1\\2" target="_blank">\\3</a>', $texte);
	$texte = preg_replace('`\[mail\](.*?@.*?\..*?)\[/mail\]`si', '<a href="mailto:\\1">\\1</a>', $texte);
	$texte = preg_replace('`\[mail=(.*?@.*?\..*?)\](.*?)\[/mail\]`si', '<a href="mailto:\\1">\\2</a>', $texte);
	$texte = preg_replace('`\[img\](.*?)(gif|jpg|jpeg|png)\[/img\]`si', '<img src="\\1\\2"  border="0">', $texte);
	$texte = preg_replace('`\[lightbox\](.*?)(gif|jpg|jpeg|png)\[/lightbox\]`si', '<a href="\\1\\2"   rel="lightbox" title=""><img style="max-width:450px" src="\\1\\2" border="0"></a>', $texte);
	
	$texte = preg_replace('`\[secret=(.*?)\](.*?)\[/secret\]`si', '<fieldset><legend>
	<div id="\\1-open" style="display:block"><a onclick="document.getElementById(\'\\1\').style.display=\'block\'; document.getElementById(\'\\1-open\').style.display=\'none\'; document.getElementById(\'\\1-close\').style.display=\'block\';">Secret : cliquez pour d&eacute;couvrir</a></div>
	<div id="\\1-close" style="display:none"><a onclick="document.getElementById(\'\\1\').style.display=\'none\'; document.getElementById(\'\\1-open\').style.display=\'block\'; document.getElementById(\'\\1-close\').style.display=\'none\';">Secret : cliquez pour d&eacute;couvrir</a></div></legend><div id="\\1" style="display:none">\\2</div></fieldset>', $texte);
	$texte = preg_replace("`\[center\](.*?)\[/center\]`si", '<center>\\1</center>', $texte);
	
	$texte = preg_replace("`\[fichier=(.*?)\](.*?)\[/fichier\]\[dll\](.*?)\[\/dll\]`si", isset($_SESSION['pseudo']) ? sprintf($theme['dll_ouvert'],'90%','\\3').'<form method="post" ><input type="submit" onclick="window.open(\'upload_fichier\/\\1\' ,\'_blank\');" value="T&eacute;l&eacute;charger" style="width:130px; height:25px" name="filesid" /><input type="hidden" name="idfiles" value="\\2">'.$okdll.'</form>'.$theme['dll_ferme'] : '<input type="button" onclick="window.open(\'registerLogin.php\' ,\'_parent\');" value="Vous devez  &ecirc;tre connect&eacute; pour T&eacute;l&eacute;charger" style="width:300px; height:25px" />'  , $texte);
	
	$texte = preg_replace("`\[cutetex\](.*?)\[/cutetex\]`si", '\\1', $texte);
	$texte = preg_replace("`\[droite\](.*?)\[/droite\]`si", '<p align="right">\\1</p>', $texte);
	$texte = preg_replace("`\[fichier=(.*?)\](.*?)\[/fichier\]`si", '<a href="\\1" title="\\2">\\2</a>', $texte);
	$texte = preg_replace('`\[item=(.*?)\](.*?)\[/item\]`si', '<a href="\\1">\\2</a>', $texte);
	$texte = preg_replace('`\[swf\](.*?)\[/swf\]`si', '<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000"  codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=5,0,0,0" width="560px" height="315px">	<param name="movie" value="\\1" /><param name="quality" value="best" /><param name="allowScriptAccess" value="always" /><param name="wmode" value="transparent" /><param name="flashvars" value="" />	<embed src="\\1" width="560px" height="315px" quality="best" allowScriptAccess="always" wmode="transparent" type="application/x-shockwave-flash" pluginspage="http://www.adobe.com/go/getflashplayer"></embed></object>', $texte);
	$texte = preg_replace('`\[youtube\]([a-zA-Z0-9&\-_]+?)\[/youtube\]`si', '<object type="application/x-shockwave-flash" data="http://www.youtube.com/v/\\1" width="425" height="350">
<param name="movie" value="http://www.youtube.com/v/\\1" />
<param name="wmode" value="transparent" />
</object>', $texte);
	$texte = preg_replace("`\[ta\](.*?)\[/ta\]`si", '<table width="100%" cellpadding="2" cellspacing="2">\\1</table>', $texte);
	$texte = preg_replace("`\[tr\](.*?)\[/tr\]`si", '<tr>\\1</tr>', $texte);
	$texte = preg_replace("`\[td\](.*?)\[/td\]`si", '<td class="moyen">\\1</td>', $texte);
	$texte = preg_replace("`\[td=(.*?)\](.*?)\[/td\]`si", '<td class="moyen" colspan="\\1">\\2</td>', $texte);
	$texte = preg_replace("`\[td=(.*?) w=(.*?)\](.*?)\[/td\]`si", '<td class="moyen" colspan="\\1" width="\\2">\\3</td>', $texte);
	
	$texte = preg_replace("`\[en=(.*?)\](.*?)\[/en\]`si", '<a name="\\1">\\2</a>', $texte);
	$texte = preg_replace('`\[id=(.*?)\](.*?)\[/id\]`si', '<a href="\\1">\\2</a>', $texte);
	$texte = preg_replace('`\[s\](.*?)\[/s\]`si', '<strike>\\1</strike>', $texte);
	

	if ( $parse_url_email )
	{
		$texte = parse_url_email($texte);
	}

	// On rtabli ensuite les &fs1; et &fs2; en [ et ]
	$texte = fs2wpmcode($texte);

	return $texte;
}

/************************************
* Parse les code pouvant s'encastrer entre eux comme les [quote] ou [list]
************************************/
function wpmcode_subparse($texte, $patern_ouvert, $patern_ferme, $theme_ouvert, $theme_ferme, $special = FALSE)
{
	global $langue, $theme;

	preg_match_all('`' . $patern_ouvert . '`si', $texte, $matches_o);
	preg_match_all('`' . $patern_ferme . '`si', $texte, $matches_f);
	$minimum = min(count($matches_o[0]), count($matches_f[0]));
	$position_o = 0;
	$position_f = 0;

	for ( $i = 0; $i < $minimum; $i++ )
	{
		$position_o = strpos($texte, $matches_o[0][$i], $position_o);
		$position_f = strpos($texte, $matches_f[0][$i], $position_f);
		if ( $position_o < $position_f )
		{
			$open = $theme_ouvert;
			
			if ($special == 'quot')
			{
				$open = sprintf($theme['quote_ouvert'], '90%', 'Citation' . ' : ' . $matches_o[2][$i]);
			}
			else if ($special == 'couleur' || $special == 'taille' )
			{
				$open = sprintf($theme_ouvert, $matches_o[2][$i]);
			}

			$texte = preg_replace('`' . preg_quote($matches_o[0][$i]) . '`si', $open, $texte, 1);
			$texte = preg_replace('`' . preg_quote($matches_f[0][$i]) . '`si', $theme_ferme, $texte, 1);
		}
	}

	return $texte;
}

function wpmcode_code($texte)
{
	global $langue, $theme;

	return sprintf($theme['code_code'], '90%', $langue['code'], $texte);
}

function wpmcode2fs($texte)
{
	$origine = array('#\[#', '#\]#');
	$remplacement = array('&fs1;', '&fs2;');
	return preg_replace($origine, $remplacement, $texte);
}

function fs2wpmcode($texte)
{
	$origine = array('#&fs1;#', '#&fs2;#');
	$remplacement = array('[', ']');
	return preg_replace($origine, $remplacement, $texte);
}

/************************************
* Supprime toutes les balises de type [texte] du message.
************************************/
function wpmcode_supprimer($texte)
{
	return preg_replace('/\[(\/?)[[:alnum:]]+\]/si', '', $texte);
}


function parse_simple_wpmcode($message, $wpmcode, $open, $close)
{
	preg_match_all("`\[$wpmcode\](.*?)\[/$wpmcode\]`si", $message, $matches);
	$nb_matches = count($matches[1]);
	$bb_length = strlen($bbcode) + 2;
	for ($i = 0; $i < $nb_matches; $i++)
	{
		if ( preg_match_all("`\[$wpmcode\](.*?)\[/$wpmcode\]`si", $matches[$i][0], $matchs) )
		{
			$nb_matchs = count($matchs[1]);
			$newm = substr($matchs[0][0], $bb_length);
			if ( preg_match("`\[$wpmcode\](.*?)\[/$wpmcode\]`si", $newm) && $nb_matchs > 0 )
			{
				$new_message = preg_replace("`\[$wpmcode\](.*?)\[/$wpmcode\]`", "\\1", $newm);
				$new_message = str_replace($newm, $new_message, $message);
				return (parse_simple_wpmcode($new_message, $wpmcode, $special, $special2));
			}
		}
	}
	$message = preg_replace("#\[$wpmcode\](.*?)\[/$wpmcode\]#si", "$open\\1$close", $message);

	return ($message);
}

/*
** Gestion des wpmcodes [list]
*/
function parse_list($str)
{
	while(preg_match('/\n?\[liste\](.+?)\[\/liste\]\n?/is', $str))
	{
	$str = preg_replace('/\n?\[liste\](.+?)\[\/liste\]\n?/ies', "subparse_list('\\1')" , $str);
	}
	return ($str);
}

function subparse_list($str)
{
	$str = preg_replace('/\[\*\]/', '</li><li>', $str);
	$str = preg_replace('/^<\/?li>/', '', $str);
	$str = str_replace( "\n</li>", '</li>', $str . '</li>');
	return '<ul>' . stripslashes($str) . '</ul>';
}



function deletephptag($texte)
{	
	function echapcode($a) {
		return '[php]'.nl2br(str_replace("&lt;br /&gt;", " ",htmlspecialchars($a[2]))).'[/php]';
	}
	$texte = preg_replace_callback("`(\<\?php)(.*?)(\?\>)`si", 'echapcode' , $texte);
	return $texte;
} 



// Fonction calendrier

 function getSecond($valeur) {
 return substr($valeur, 17, 2);
   }

   function getMinute($valeur) {
       return substr($valeur, 14, 2);
   }

  function getHour($valeur) {

      return substr($valeur, 11, 2);
  }

  function getDay($valeur)     {
     return substr($valeur, 8, 2);
  }

  function getMonth($valeur)     {
     return substr($valeur, 5, 2);
  }

  function getYear($valeur) {
     return substr($valeur, 0, 4);
 }

  function monthNumToName($mois) {
    $tableau = Array("", "Janvier", "F&eacute;vrier", 
    "Mars", "Avril", "Mai", "Juin", "Juillet", 
    "A&ocirc;ut", "Septembre", "Octobre", "Novembre", "D&eacute;cembre");

    return (intval($mois) > 0 && intval($mois) 
    < 13) ? $tableau[intval($mois)] : "Indfini";
  }


?>